# Smart3D

* 南方智能的3维场景开发API库
* 敏捷性开发
* 独立的UI和功能实现
* 支持点云，倾斜，地形快速和部分性加载处理

## 如何使用？

首先，我们提供两种使用方式`npm`包和`cdn`资源引入方式

#### npm 使用，只支持内部使用，包是放在私库
```shell
npm install --save smart3d --registry http://172.16.10.131:4873

# or use the ssnpm
ssnpm install --save smart3d
```

安装好后，可以在项目使用，比如：
```js
import smart3d from 'smart3d';
import 'smart3d/dist/smart3d/smart3d.css';
```

#### cdn引入使用

先[下载文件](http://www.south-smart.com/smartmap/smart3d/download)，再引入使用

```html
<link rel="stylesheet" href="../smart3d.css">
<srcipt type="text/javascript" src="./smart3d.js"></script>
```

### 提示

`SMART3D_BASE_URL` 若是引入相对路径时，可以不能写，但若是出现静态资源加载404，需要设置该值，让库去找你的静态位置
```
window.SMART3D_BASE_URL = 'smart3d' // smart3d的路径
```

## 例子

引入做好后，正式进入开发了，比如下面简单创建Viewer:
```js
var viewer = new smart3d.Viewer('container', {
  sceneMode: smart3d.SceneMode.SCENE3D,
  scene3DOnly: true
});
```

再比如距离测量：
```js
var distanceHandler = new smart3d.MeasureHandler(viewer, smart3d.MeasureMode.Distance);
distanceHandler.activate();
```
